
From: Peter Osterlund <petero2@telia.com>

Here is a fix for synaptics touchpads with "multi buttons". The patch
comes from Hartwig Felger, who wrote the original multi button support
patch (p00003_synaptics-multi-button.patch). The same bug fix has been
included in the XFree86 driver for a few weeks, and seems to work
fine. (That part of the X driver is only used for 2.4 kernels.)



 drivers/input/mouse/synaptics.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletion(-)

diff -puN drivers/input/mouse/synaptics.c~syn-multi-btn-fix drivers/input/mouse/synaptics.c
--- 25/drivers/input/mouse/synaptics.c~syn-multi-btn-fix	2003-08-14 11:59:32.000000000 -0700
+++ 25-akpm/drivers/input/mouse/synaptics.c	2003-08-14 11:59:32.000000000 -0700
@@ -433,7 +433,8 @@ static void synaptics_parse_hw_state(uns
 			if (hw->right)
 				hw->down = !hw->down;
 		}
-		if (buf[3] == 0xC2 && SYN_CAP_MULTI_BUTTON_NO(priv->ext_cap)) {
+		if (SYN_CAP_MULTI_BUTTON_NO(priv->ext_cap) &&
+		    ((buf[3] & 2) ? !hw->right : hw->right)) {
 			switch (SYN_CAP_MULTI_BUTTON_NO(priv->ext_cap) & ~0x01) {
 			default:
 				; /* we did comment while initialising... */

_
